/*
 * BMB.java
 * Stephen M. Bennett
 * Created on Jul 3, 2004
 *
 * This matches KINT's BMB structure for a bitmap buffer
 */

package stephen.bennett.kint;

import java.awt.Image;

public class BMB {
  
  // the parts, as defined in KINT's BMB
  
  // we hold the byte array in an Image object
  Image pBits;
  
  // we holds the AND byte array in an Image object
  Image pAND;
  
  int linelen, orient, physW, physH, logW, logH;  // is short in KINT
  int clipX1, clipX2, clipY1, clipY2;

  
  // construct ourself
  public BMB(int w, int h, Image image) {
    // force line of pixels to take even number of DWORDS
    // *** will this be a problem for us?  as we don't create array using this computed value, it is already created
    linelen = 4*((3*w+3)/4);	
    pAND = null;
    physW = w;
    physH = h;
    clipX1 = clipY1 = 0;
    clipX2 = w;
    clipY2 = h;
    logW = w;
    logH = h;
    orient = UI.BMO_NORMAL;
  }

  
  // return our image
  public Image getImage() {
    return pBits;
  }

  // return our logW
  public int getLogW() {
    return logW;
  }

  // return our logH
  public int getLogH() {
    return logH;
  }

  // return our orient
  public int getOrient() {
    return orient;
  }

}
