// A Java version for the Kaser Interpreter - The Mouse Motion Listener
// For some of my own fun!
// Stephen M. Bennett
// 29Jun02 Started

package stephen.bennett.kint;


import java.awt.event.*;


// Map interesting mouse motion events to calls on KE Event

class KMouseMotionListener extends MouseMotionAdapter {
  // the mouse is moved (with no key down)
  public void mouseMoved(MouseEvent e) {
    Log.fine("Mouse Moved event happened");

    processMouseEvent(e);
  }

  // the mouse is dragged (i.e. with key down)
  public void mouseDragged(MouseEvent e) {
    Log.fine("Mouse Dragged event happened");

    processMouseEvent(e);
  }


  // common method to call keEvent for this Mouse Event
  private static void processMouseEvent(MouseEvent e) {
    // Log.fine("MouseEvent is "+e);

    // get the x and y 
    int x = e.getX();
    int y = e.getY();

    // compute the flags
    int flags = KMouseListener.mouseEventToFlags(e);

    // using same cursor logic and KINT.EXE
    // set the cursor to -1 (unset)
    UI.setCursor(UI.CURSOR_NONE);

    // call the .KE function
    Log.info("Calling KEEVENT_POINTER_MOVE");
    KInt.keEvent(KInt.KEEVENT_POINTER_MOVE, x, y, flags);

    // using same cursor logic as KINT.EXE
    UI.showCursor();

    // this was an interesting event
    UI.setMostRecentEventTime();
  }



  // Return our CVS id
  public static String getCVSID() {
    return "$Id: KMouseMotionListener.java,v 1.2 2002/10/06 15:28:14 Bennett Stephen Exp $";
  }

}


/*
 * $Log: KMouseMotionListener.java,v $
 * Revision 1.2  2002/10/06 15:28:14  Bennett Stephen
 * CVS method added and cursor calls
 *
 * Revision 1.1  2002/08/07 19:22:21  Bennett Stephen
 * Initial Version
 *
 *
 */

// ----------------------------------------------------
// Emacs magic - please do not remove the following lines
/*
 * Local Variables:
 * write-contents-hooks: ((lambda () (untabify (point-min) (point-max))))
 * End:
*/
// ----------------------------------------------------
